<?php

if(!function_exists('am_require')) {
	function am_require( $path, $file ) {
		if( is_array($path) ) {
			$paths = array();
			foreach($path as $p) {
				$paths[] = am_require($p, $file);
			}
			return $paths;
		}

		$path = plugin_dir_path( $file ) . $path;
//        var_dump($path);
		if ( file_exists( $path ) ) {
			require_once( $path );
			return $path;
		}

		return false;
	}
}

if(!function_exists('am_id')) {
	$__am_id_count = 0;
	function am_id( $prefix = 'cmp' ) {
		global $__am_id_count;
		return $prefix . ++$__am_id_count;
	}
}
if(!function_exists('am_is_integer')) {
	function am_is_integer( $input ) {
		return ( ctype_digit( strval( $input ) ) );
	}
}
if(!function_exists('am_array_param_search')) {
	function am_array_param_search($key, $value, $array) {
		foreach ($array as $akey => $aval) {
			if (is_array($aval) && $aval[$key] === $value) {
				return $akey;
			}
			if (is_object($aval) && $aval->$key === $value) {
				return $akey;
			}
		}
		return null;
	}
}
if(!function_exists('am_echo_template')) {
	function am_echo_template( $path, $file, $data = null ){
		$path = plugin_dir_path( $file ) . $path;

		$data = (array) $data;
		if(is_array($data)) extract($data);

		if(file_exists($path))
			require($path);
	}
}
if(!function_exists('am_template')) {
	function am_template( $path, $file, $data = null ){
		ob_start();
		am_echo_template( $path, $file, $data );
		return ob_get_clean();
	}
}
if(!function_exists('am_join')) {
	function am_join($glue){
		$args = func_get_args();
		array_shift($args);
		return join($glue, $args);
	}
}
if(!function_exists('am_if')) {
	function am_if($val, $if, $else = null){
		if( !empty($val) || $val === 0 || $val === '0' ) { //  || $val === false
//		if( $val || $val === false || $val === 0 || $val === '0' ) {
			return $if;
		} else {
			return $else;
		}
	}
}
if(!function_exists('am_e_if')) {
	function am_e_if($val, $if, $else = null){
		echo am_if($val, $if, $else);
	}
}
if(!function_exists('am_is_vc')) {
	function am_is_vc(){
		return is_admin() && defined( 'WPB_VC_VERSION' );
	}
}
if(!function_exists('am_adjust_brightness')) {
	function am_adjust_brightness( $hex, $steps ) {
		$steps = max( - 255, min( 255, $steps ) );

		$hex = str_replace( '#', '', $hex );
		if ( strlen( $hex ) == 3 ) {
			$hex = str_repeat( substr( $hex, 0, 1 ), 2 ) . str_repeat( substr( $hex, 1, 1 ), 2 ) . str_repeat( substr( $hex, 2, 1 ), 2 );
		}

		$r = hexdec( substr( $hex, 0, 2 ) );
		$g = hexdec( substr( $hex, 2, 2 ) );
		$b = hexdec( substr( $hex, 4, 2 ) );

		$r = max( 0, min( 255, $r + $steps ) );
		$g = max( 0, min( 255, $g + $steps ) );
		$b = max( 0, min( 255, $b + $steps ) );

		$r_hex = str_pad( dechex( $r ), 2, '0', STR_PAD_LEFT );
		$g_hex = str_pad( dechex( $g ), 2, '0', STR_PAD_LEFT );
		$b_hex = str_pad( dechex( $b ), 2, '0', STR_PAD_LEFT );

		return '#' . $r_hex . $g_hex . $b_hex;
	}
}
if(!function_exists('am_hex2rgb')) {
	function am_hex2rgb($hex) {
		$hex = str_replace("#", "", $hex);

		if(strlen($hex) == 3) {
			$r = hexdec(substr($hex,0,1).substr($hex,0,1));
			$g = hexdec(substr($hex,1,1).substr($hex,1,1));
			$b = hexdec(substr($hex,2,1).substr($hex,2,1));
		} else {
			$r = hexdec(substr($hex,0,2));
			$g = hexdec(substr($hex,2,2));
			$b = hexdec(substr($hex,4,2));
		}
		$rgb = array($r, $g, $b);
		//return implode(",", $rgb); // returns the rgb values separated by commas
		return $rgb; // returns an array with the rgb values
	}
}
if(!function_exists('am_hex2rgb_css')) {
	function am_hex2rgb_css($hex) {
		$css = am_hex2rgb($hex);

		return 'rgb(' . join(', ', $css) . ')';
	}
}