<?php
if (!class_exists('Amino_internal_arrayToHTMLAttributesInstance')) {
	class Amino_internal_arrayToHTMLAttributesInstance {
		function __construct($attributes) {
			$this->attributes = $attributes;
		}

		function _do( $key ) {
			$attributes = $this->attributes;

			if ( is_bool( $attributes[ $key ] ) ) {
				return $key . '="' . ( $attributes[ $key ] ? 1 : 0 ) . '"';
//						return $attributes[$key]?$key:'';
			}

			return $key . '="' . $attributes[ $key ] . '"';
		}
	}
}
if (!class_exists('Amino_internal_arrayToHTMLStyles')) {
	class Amino_internal_arrayToHTMLStyles {
		function __construct($attributes) {
			$this->attributes = $attributes;
		}

		function _do( $key ) {
			return $key . ':' .  $this->attributes[ $key ];
		}
	}
}

if(!function_exists('am_arrayToHTMLStyles')) {
	function am_arrayToHTMLStyles( $attributes ) {
		if ( ! $attributes ) {
			return '';
		}
		if ( ! is_array( $attributes ) ) {
			return $attributes;
		}

		foreach ( $attributes as $key => $attribute ) {
			if ( ! $attributes[ $key ] || $attributes[ $key ] == '' ) {
				unset( $attributes[ $key ] );
			}
		}

		$i = new Amino_internal_arrayToHTMLStyles($attributes);

        if(!count($i->attributes)) return '';

		return join(
			       '; ',
			       array_map(
				       array($i, '_do'),
				       array_keys( $attributes )
			       )
		       ) . '; ';
	}
}

if(!function_exists('am_arrayToHTMLAttributes')) {
	function am_arrayToHTMLAttributes( $attributes ) {
		if ( ! $attributes || ! is_array( $attributes ) ) {
			return '';
		}

		foreach ( $attributes as $key => $attribute ) {
			if ( $attributes[ $key ] === false || $attributes[ $key ] === true ) {
				continue;
			}
			if ( ! $attributes[ $key ] || $attributes[ $key ] == '' ) {
				unset( $attributes[ $key ] );
			} else if ( is_array( $attribute ) ) {
				$attributes[ $key ] = join( ' ', $attribute );
			}
		}

		$i = new Amino_internal_arrayToHTMLAttributesInstance($attributes);

		return join(
			' ',
			array_map(
				array($i, '_do'),
				array_keys( $attributes )
			)
		);
	}
}

if(!function_exists('am_attr')) {
	function am_attr( $styles ) {
		return am_arrayToHTMLAttributes($styles);
	}
}
if(!function_exists('am_attr_style')) {
	function am_attr_style( $styles ) {
		return am_arrayToHTMLStyles($styles);
	}
}
if(!function_exists('am_dom')) {
	function am_dom( $attrs, $content = '' ) {
		$tag = 'div';
		if ( isset( $attrs['tag'] ) ) {
			$tag = $attrs['tag'];
			unset( $attrs['tag'] );
		}

		if ( isset( $attrs['style'] ) ) {
			$attrs['style'] = am_arrayToHTMLStyles( $attrs['style'] );
		}

		$inline = am_arrayToHTMLAttributes( $attrs );

		if ( is_array( $content ) ) {
			$content = join( '', $content );
		}

		if ( in_array( $tag, array( 'input', 'img' ) ) ) {
			$html = '<' . $tag . ' ' . $inline . ' />';
		} else {
			$html = '<' . $tag . ' ' . $inline . '>' . $content . '</' . $tag . '>';
		}


		return $html;
	}
}
if(!function_exists('am_dom_input')) {
	function am_dom_input( $name, $value, $attrs) {
		$attrs['tag'] = 'input';
		$attrs['name'] = $name;
		if($value) $attrs['value'] = $value;

		return am_dom( $attrs );
	}
}
if(!function_exists('am_dom_class')) {
	function am_dom_class( $cls, $content) {
		return am_dom( array('class'=>$cls), $content );
	}
}