<?php

if(!function_exists('am_inline_style')) {
	function am_inline_style( $handler, $rule,  $styles ) {
        $st = am_arrayToHTMLStyles($styles);
        if(!$st) return;

		$css = sprintf('%s { %s }', $rule, $st);

		wp_add_inline_style( $handler, $css );

		return $css;
	}
}

if(!function_exists('am_inline_style_id')) {
    function am_inline_style_id( $id, $handler, $rule,  $styles ) {
        return am_inline_style($handler, '#'. $id . $rule, $styles);
    }
}


if(!function_exists('am_inline_style_return')) {
	function am_inline_style_return( $rule,  $styles ) {
		$st = am_arrayToHTMLStyles($styles);
		if(!$st) return;

		$css = sprintf('%s { %s }', $rule, $st);

		return $css;
	}
}

if(!function_exists('am_style')) {
	function am_style( $file, $__FILE__, $handle_prefix, $use_minified = false, $deps = array(), $ver = false ) {
		$handle = $handle_prefix . '-' . str_ireplace( '/', '-', $file );

		wp_enqueue_style( $handle, plugins_url( $file . ( $use_minified ? '.min' : '' ) . '.css', $__FILE__ ), $deps, $ver );

		return $handle;
	}
}

if(!function_exists('am_script')) {
	function am_script( $file, $__FILE__, $handle_prefix, $use_minified = false, $deps = array(), $ver = false ) {
		$handle = $handle_prefix . '-' . str_ireplace( '/', '-', $file );

		wp_enqueue_script( $handle, plugins_url( $file . ( $use_minified ? '.min' : '' ) . '.js', $__FILE__ ), $deps, $ver );

		return $handle;
	}
}