<?php
/*
Plugin Name: Snow 3D for WordPress
Plugin URI: http://amino-studio.com/snow-3d/
Description: Christmas Plugin
Version: 1.0.1
Text Domain: snow-3d
Author: Amino-Studio <support@amino-studio.com>
Author URI: http://amino-studio.com/
License: http://amino-studio.com/license/
*/

if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

class Snow3d_Main {
	var $SLUG = 'snow-3d';
	var $VERSION = '1.0.2';
	var $name;

	var $USE_MINIFIED = true;
	var $IS_DEBUG = false;
	var $plugin__FILE__;

	function __construct() {
		add_action( 'init', array( $this, 'init' ), 110 );
		add_action( 'wp', array( $this, 'wp' ), 1 );
	}

	public function init() {
		if ( isset( $_REQUEST['nomin'] ) ) {
			$this->USE_MINIFIED = false;
		}
		$this->IS_DEBUG = defined( 'WP_DEBUG' ) && WP_DEBUG === true;
//		$this->IS_DEBUG = true;

		if ( $this->IS_DEBUG ) {
			$this->USE_MINIFIED = false;
		}

		$this->plugin__FILE__ = __FILE__;

		require_once( plugin_dir_path( __FILE__ ) . 'amino/load.php' );

		if ( is_admin() ) {
//			$data       = get_plugin_data( __FILE__ );
			$this->name = 'Snow 3D for WordPress';//$data['Name'];

			$this->initSettings();
		}
	}

	public function wp() {
		if ( is_admin() ) return;

		$settings = get_option( $this->SLUG );

		if($settings['enabled']) {
			if(!is_array(@$settings['specialPages'])) {
				$settings['specialPages'] = array();
			}
			if(!$settings['allPages'] && !in_array(get_the_ID(), $settings['specialPages'])) {
				return;
			}

			am_script( 'library/snow-3d/snow-3d-vendor', __FILE__, $this->SLUG, $this->USE_MINIFIED, array('jquery'), $this->VERSION );
			am_script( 'library/snow-3d/snow-3d', __FILE__, $this->SLUG, $this->USE_MINIFIED, array('jquery'), $this->VERSION );
			$loaderHandler = am_script( 'library/snow-loader', __FILE__, $this->SLUG, $this->USE_MINIFIED, null, $this->VERSION );


			$images = array();
//			var_dump($settings['default-images']);
			if(!$settings['default-images'] || !is_array($settings['default-images'])) {
				$settings['default-images'] = array();
				for($i=1;$i<5;$i++) {
					$settings['default-images']['flake'.$i] = '1';
				}

			}

			foreach( $settings['default-images'] as $file => $fileIsEnabled ) {
				if($fileIsEnabled) {
					$images[] = plugins_url(sprintf('library/snow-3d/flakes/%s.png', $file), __FILE__);
				}
			}

//			if(!$images || count($images) == 0) {
//				for($i=1;$i<5;$i++)
//					$images[] = plugins_url(sprintf('library/snow-3d/flakes/%s.png', 'flake'.$i.'.png'), __FILE__);
//			}

			$frontSettings = array();
			$frontSettings['prefix'] = 'snow3d';
			$frontSettings['num'] = (int) $settings['num'];
			$frontSettings['speed'] = (float) $settings['speed'];
			$frontSettings['direction'] = $settings['direction'] == 'up' ? 'up' : 'down';
			$frontSettings['disableMouse'] = $settings['disableMouse'] == 1 ? 'true' : 'false';
			$frontSettings['enableMobile'] = $settings['enableMobile'] == 1 ? 'true' : 'false';
			$frontSettings['fadeScroll'] = $settings['fadeScroll'] == 1 ? 'true' : 'false';

			if($settings['showOnce'] == 'days') {
				$settings['showOnce'] = $settings['showOnceDays'].'';
			}
			$frontSettings['showOnce'] = $settings['showOnce'];


			if($settings['closeButton'] == '1') {
				$settings['closeButton'] = $settings['closeButtonText'];
			} else {
				$settings['closeButton'] = '0';
			}
			$frontSettings['closeButton'] = $settings['closeButton'];
			$frontSettings['closeButtonStyles'] = $settings['closeButtonStyles'];

			if($settings['closeButtonMode'] == 'days') {
				$settings['closeButtonMode'] = $settings['closeButtonModeDays'].'';
			}
			$frontSettings['closeButtonMode'] = $settings['closeButtonMode'];

			$frontSettings['minScale'] = $settings['scale'][1];
			$frontSettings['maxScale'] = $settings['scale'][2];
			$frontSettings['url'] = '';
			$frontSettings['images'] = join(',', $images);

			wp_localize_script( $loaderHandler, 'snow3dSettings', $frontSettings );
		}

//			var_dump($settings);
	}

	protected function initSettings() {
		am_require( 'vendor/ReduxCore/framework.php', __FILE__ );
//		am_require( 'settings/sample-config.php', __FILE__ );
		am_require( 'settings/config.php', __FILE__ );
		new Snow3d_settings_config( $this );

		if(!$this->IS_DEBUG) {
			$options = get_option( $this->SLUG );
			if ( @$options['auto_updates_key'] && @$options['auto_updates_enable'] ) {
				require_once( 'wp-updates-plugin.php' );
				new WPUpdatesPluginUpdater_724( 'http://wp-updates.com/api/2/plugin', plugin_basename( __FILE__ ) );
			} else {
				add_action( 'admin_notices', array( &$this, 'noticeLicenseActivation' ) );
			}
		}
	}

	public function noticeLicenseActivation() {
		echo '<div class="updated activation-notice"><p>' .
		     sprintf( __( 'Please <a href="%s">activate your copy</a> of %s to receive automatic updates.', $this->SLUG ), wp_nonce_url( admin_url( 'options-general.php?page=' . $this->SLUG . '&tab=1' ) ), $this->name ) . '</p></div>';
	}
}

new Snow3d_Main();
