<?php

    /**
     * Redux Framework is free software: you can redistribute it and/or modify
     * it under the terms of the GNU General Public License as published by
     * the Free Software Foundation, either version 2 of the License, or
     * any later version.
     * Redux Framework is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
     * GNU General Public License for more details.
     * You should have received a copy of the GNU General Public License
     * along with Redux Framework. If not, see <http://www.gnu.org/licenses/>.
     *
     * @package     ReduxFramework
     * @subpackage  Field_Gallery
     * @author      Abdullah Almesbahi (cadr-sa)
     * @version     3.0.0
     */

// Exit if accessed directly
    if ( ! defined( 'ABSPATH' ) ) {
        exit;
    }

// Don't duplicate me!
    if ( ! class_exists( 'ReduxFramework_custom_gallery' ) ) {

        /**
         * Main ReduxFramework_gallery class
         *
         * @since       3.0.0
         */
        class ReduxFramework_custom_gallery {

            function __construct( $field = array(), $value = '', $parent ) {
                $this->parent = $parent;
                $this->field  = $field;
                $this->value  = $value;
            }

            public function render() {
                echo '<div class="screenshot">';

                if ( ! empty( $this->value ) ) {
                    $ids = explode( ',', $this->value );

                    foreach ( $ids as $attachment_id ) {
                        $img = wp_get_attachment_image_src( $attachment_id, 'thumbnail' );
                        echo '<a class="of-uploaded-image" href="' . $img[0] . '">';
                        echo '<img class="redux-option-image" id="image_' . $this->field['id'] . '_' . $attachment_id . '" src="' . $img[0] . '" alt="" target="_blank" rel="external" />';
                        echo '</a>';
                    }
                }

                echo '</div>';

	            $addButton = __( 'Add/Edit Gallery', 'redux-framework' ) ;
	            $clearButton = __( 'Clear Gallery', 'redux-framework' ) ;
	            if($this->field['addButton']) $addButton = $this->field['addButton'];
	            if($this->field['clearButton']) $clearButton = $this->field['clearButton'];

                echo '<a href="#" onclick="return false;" id="edit-gallery" class="gallery-attachments button button-primary">' . $addButton . '</a> ';
                echo '<a href="#" onclick="return false;" id="clear-gallery" class="gallery-attachments button">' . $clearButton . '</a>';
                echo '<input type="hidden" class="gallery_values ' . $this->field['class'] . '" value="' . esc_attr( $this->value ) . '" name="' . $this->field['name'] . $this->field['name_suffix'] . '" />';
            }

            public function enqueue() {

                if ( function_exists( 'wp_enqueue_media' ) ) {
                    wp_enqueue_media();
                } else {
                    wp_enqueue_script( 'media-upload' );
                    wp_enqueue_script( 'thickbox' );
                    wp_enqueue_style( 'thickbox' );
                }

                wp_enqueue_script(
                    'redux-field-custom-gallery-js',
                    plugins_url('field_custom_gallery' . Redux_Functions::isMin() . '.js', __FILE__),
                    array( 'jquery', 'redux-js' ),
                    time(),
                    true
                );
            }
        }
    }